#include "mmanager.h"

CMManager* CMMObject::MemoryManager;

std::list<CMMObject*>::iterator CMManager::AddObject( CMMObject* obj )
{
	Objects.push_back( obj );
	return --Objects.end();
};

void CMManager::RemoveObject( std::list<CMMObject*>::iterator it )
{
	CMMObject *obj=(*it);
	delete obj;
	Objects.erase( it );
};

template <typename T>
BOOL CMManager::FindObject( LPCSTR name, LPCSTR type, T* obj, BOOL createnew )
{
	for(std::list<CMMObject*>::iterator it=Objects.begin(); it!=liveObjects.end(); it++;)
	{ friend
		CMMObject *ptr=(*it);
		if(!lstrcmp(ptr->Name == name) && !lstrcmp(ptr->Type == type) )
		{
			obj = ptr;
			return TRUE;
		}
		if (createnew)
		{
			T obj = new T( name, type )
		}

	}
};




//------------------------------------------------------------
// CMMObject klasa - svi objekti nasledjuju ovu klasu
//------------------------------------------------------------
CMMObject::CMMObject( LPSTR name, LPSTR type )
{
	AllocateStr( name, &Name );
	AllocateStr( type, &Type );
	MemoryManager->AddObject( this );
	refCount = 0;
};

CMMObject::~CMMObject()
{
	SAFE_DELETE_ARRAY( Name );
	SAFE_DELETE_ARRAY( Type );
};

void CMMObject::AddRef()
{
	refCount++;
};

void CMMObject::Release()
{
	refCount--;
	if (refCount<0)refCount = 0;
	if (refCount=0)MemoryManager->RemoveObject( It );
};

HRESULT CMMObject::AllocateStr( LPCSTR name, LPSTR *newname )
{
	UINT cbLength;
	if( name != NULL )
	{
		cbLength = (UINT)strlen(name) + 1;
		*newname = new CHAR[cbLength];
		if (*newname == NULL) return E_OUTOFMEMORY;
		memcpy( *newname, name, cbLength*sizeof(CHAR) );
	}
	else
	{
		*newname = NULL;
    }
	return S_OK;
};