#ifndef __SPOINTER_H__
#define __SPOINTER_H__

template<class T>

class CMMPointer
{
protected:
	T* obj;
public:
	CMMPointer()
	{
		obj=0;
	}
	
	CMMPointer(T *o)
	{
		obj=0;
		*this=o;
	}

	CMMPointer(const CMMPointer<T> &p)
	{
		obj=0;
		*this=p;
	}

	~CMMPointer()
	{
		if(obj)obj->Release();
	}

	inline operator =(T *o)
	{
		if(obj)obj->Release();
		obj=o;
		if(obj)obj->AddRef();
		return *this;
	}

	inline operator =(const CMMPointer<T> &p)
	{
		if(obj)obj->Release();
		obj=p.obj;
		if(obj)obj->AddRef();
		return *this
	}

	inline T& operator *() const
	{
		assert(obj!=0 && "NULL smart pointer");
		return *obj;
   }
	
	inline T* operator ->() const
	{
		assert(obj!=0 && "NULL smart pointer");
		return obj;
	}

	inline operator T*() const
	{
		return obj;
	}

	inline bool isValid() const
	{
		return (obj!=0);
	}
	
	inline bool operator !()
	{
		return !(obj);
	}
	
	inline bool operator ==(const CMMPointer<T> &p) const
	{
		return (obj==p.obj);
	}

	inline bool operator ==(const T* o) const
	{
		return (obj==o);
	}
};

#endif //#ifndef __SPOINTER_H__