#ifndef __TEXTUREOBJ_H__
#define __TEXTUREOBJ_H__

#include "mmanager.h"
#include <d3dx9.h>

class CMMTexture : public CMMObject
{
protected:
	LPDIRECT3DTEXTURE9 Texture;
	void CleanUp()
	{
		SAFE_RELEASE( Texture );
	};

public:
	CMMTexture( LPSTR name, LPSTR type = "TEX" ) : CMMObject ( name, type )
	{
		Texture = NULL;
	};

	~CMMTexture()
	{
		CleanUp();
	};

	HRESULT LoadTexture( LPDIRECT3DDEVICE9 pDevice, LPCTSTR pSrcFile )
	{
		CleanUp();
		return D3DXCreateTextureFromFile( pDevice, pSrcFile, &Texture );
	};


	inline operator LPDIRECT3DTEXTURE9(){return Texture;};
	
};



#endif //#ifndef __TEXTUREOBJ_H__